/* MulBlast reprend les fichiers BLAST pour la visualisation sous forme d'alignment multiple */
/* Compilation : cc, gcc ou c89 sans librairie particuliere et avec toute option d'optimisation (-O3). */
/* Compatibilite : LineUp et ProfileMake de GCG */

#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "mulblast.h"

/*--------------------------------------------------------------*/
/* variables							*/
/*--------------------------------------------------------------*/
FILE	*out = NULL, *in = NULL;

char	file_in[LINE_LENGTH], file_out[LINE_LENGTH]; 

int 	ordre_max = 0, ligne_max = SET_LINE,
	CONS = 0, HTML = 0, SCO = 0, PDB = 0, fout = 0, entree = 0,
	num = 0, numN = 1, numC = MAX_C, num_n_abs = 0, N_TOT = 0, TOT = 0;

double	score_max = 0.01;

/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
int parseargstr(int argc,char **argv)
{
  
int	i = 1, j, compteur = 0;
char	enter[30], *tok = NEWN(LINE_LENGTH, char);

	fprintf(stdout,"\n\n\t  Mulblast writes a multiple alignment MSF file from a BlastP output\n\n");

  if (argc == 1)
	fprintf(stdout,"\n\n\t use : mulblast input [output] [-l _] [-s _] [-c]\n\n");

  if (argc == 2){
  	strcpy(file_in,argv[1]);
	entree = 1;
	i = 1;
  }else 
  if (argc > 2 && strncmp(argv[1],"-", 1)){
  	strcpy(file_in,argv[1]);
	entree = 1;
        i++;
	if ( strncmp(argv[2],"-", 1)){
  		strcpy(file_out,argv[2]);
		fout = 1;
        	i++;
	}
  } 
  for (; i < argc; i++) {
					    /* fichier d'origine */
       if (!strcmp(argv[i],"-i")) {	
	  entree = 1;
          strcpy(file_in,argv[i+1]);
          i++;
        }
					    /* fichier de sortie */
       if (!strcmp(argv[i],"-o")) {	
	  fout = 1;
          strcpy(file_out,argv[i+1]);
          i++;
        }
       if (!strcmp(argv[i],"-c")) {	
	  CONS = 1;
        }
       if (!strcmp(argv[i],"-t")) {	
		sscanf(argv[i+1],"%d",&TOT);
          i++;
        }
       if (!strcmp(argv[i],"-s")) {	
		sscanf(argv[i+1],"%lf",&score_max);
		SCO = 1;
          i++;
        }
       if (!strcmp(argv[i],"-l")) {	
		sscanf(argv[i+1],"%d",&ligne_max);
          i++;
        }
   }

if (entree == 0){
	fprintf(stdout, "\n What is the input file ? ");
	gets(enter);
	sscanf(enter,"%s",file_in);
}	
if ((in = fopen(file_in,"r"))== NULL){
	fprintf(stdout, "\n input file '%s' not found\n",file_in);
	return 0;
}

if (fout == 0) {
	for (i = 0; i<strlen(file_in); i++)
		if (file_in[i] == '/')
			compteur = i+1;
	strcpy(enter,file_in+compteur);
	tok = strtok(enter," .");
	strncpy(file_out,tok,10);
	strcat(file_out,".blm");
	printf("\n What is the output file (* %s *)? ", file_out);
	gets(enter);
	sscanf(enter,"%s",file_out);
}
if ((out = fopen(file_out,"w"))== NULL){
	fprintf(stdout, "\n input file %s not found\n",file_in);
	exit(1);
}

return(i);
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
SEQ	*new_seq(SEQ *p, int taille)
{
	int i;

	p = NEWN(1,SEQ);
	if (!(p->sek = NEWN(taille+1, RES) )) return NULL;

	for (i = 0; i <= taille; i++)
		p->sek[i].let = VIDE;

return p;
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
static aa *new_aa(void)

{
	aa *a;

	if (! (a= NEW(aa))) return NULL; 

	memset((aa *)a, 0, sizeof(aa));

return a;
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
int	size_html(char line[LINE_LENGTH])
{
	int	i, p, html_ref = 0;
	char	*deli = "|";
	
	p = strcspn(line,deli);	
	if (!strncmp(line+p+1,"<A HREF",7)){
		html_ref = strcspn(line+p+1,deli)+p+1;
		return html_ref - 9;
	}

return 0;
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
SEQ	*prot_name(SEQ *cur_s,char line[LINE_LENGTH], int nombre)
{ 
	char	*delim1 = "|";
	int	pos, html_ref = 0, i;
	SEQ	*prev_s = cur_s;

	if ( !(cur_s = new_seq(cur_s, N_TOT)) ) return NULL;

	cur_s->prev = prev_s;
	prev_s->next =cur_s ;
	cur_s->ordre = nombre;
	cur_s->next= NULL;
	cur_s->num_N = MAX_LENGTH;
	cur_s->num_C = 0;
	cur_s->check = 0;
	
	sprintf(cur_s->code,"%d",cur_s->ordre);
	sprintf(cur_s->name,"%d",cur_s->ordre);
	if (PDB == 1 && strncmp(line,"</form>",7) == 0){
		strncpy(cur_s->bank,"pdb", 3);
		sscanf(line+20,"%6s",cur_s->code);
		sscanf(line+20,"%10s",cur_s->name);
		/*strncpy(cur_s->code,line+20,6);	
		strncpy(cur_s->name,line+20,10);*/
	}
	else
	if (strncmp(&line[1],"pdb",3) == 0){
		strncpy(cur_s->bank,"pdb", 3);
		strncpy(cur_s->code,line+5,4);	
		strncpy(cur_s->name,line+5,4);
	}
	else {
		if (!strncmp(line+3,"|",1) || !strncmp(line+4,"|",1)){
			pos = strcspn(line,delim1);	
			strncpy(line + 1, cur_s->bank, pos);
			if (!strncmp(line+pos+1,"<A HREF",7)){
				html_ref = strcspn(line+pos+1,delim1)+pos+1;
				sscanf(line + html_ref -10,"%6s",cur_s->code);
				sscanf(line + html_ref + 1,"%10s",cur_s->name);
			}
			else{
				sscanf(line + pos + 1,"%6s",cur_s->code);
				sscanf(line + pos + 8,"%10s",cur_s->name);
			}
		}
		else{
		   for (i = 0; i < LINE_LENGTH; i++)
			if (strncmp(line+i,"|",1) == 0)
				break;
		   if (i < LINE_LENGTH){
			pos = strcspn(line,delim1);	
			strncpy(line + 1, cur_s->bank, pos);
			if (!strncmp(line+pos+1,"<A HREF",7)){
				html_ref = strcspn(line+pos+1,delim1)+pos+1;
				sscanf(line + html_ref -10,"%6s",cur_s->code);
				sscanf(line + html_ref + 1,"%10s",cur_s->name);
			}
			else{
				sscanf(line + pos + 1,"%6s",cur_s->code);
				sscanf(line + pos + 8,"%10s",cur_s->name);
			}
		   }
		   else {
			strncpy(cur_s->bank,"other", 3);
			sscanf(line + 1,"%6s",cur_s->code);
			sscanf(line + 1,"%10s",cur_s->name);
		   }
		}
	}
	for (i = 0; i < LINE_LENGTH; i++)
		line[i] = '\0';
return cur_s;
}
/*--------------------------------------------------------------*/
/* calcul de la valeur 'Check' pour la compatibilite avec GCG	*/
/*--------------------------------------------------------------*/
static int SeqGCGCheckSum(SEQ *s, int longueur, int start)
{

	int 	i;
	long 	check = 0;

	for (i = 0; i < longueur ; i++){
		check += ((i%57) + 1) * s->sek[i+start].let;
	}

return (check%10000);
}
/*---------------------------------------------------------------*/
/* Calcul du consensus (strict, hydrophobe ou large) 		 */
/*---------------------------------------------------------------*/
SEQ *homologie(SEQ *first_S, int ANN, int ANC, int total)
{

	int	i,j;
	SEQ	*cur_s, *last, *homos = NULL;

	for (last = first_S; last->ordre < total; last = last->next)
		; 
	homos = new_seq(last, N_TOT);
	homos->prev = last;
	last->next = homos ;
	homos->next = NULL;
	strncpy(homos->name,"consensus",10);
	homos->ordre = total+1;
	homos->num_N = ANN;
	homos->num_C = ANC;
	homos->check = 0;

for (i = ANN; i < ANC; i++) {	
	if (first_S->sek[i].let == '.')
		continue;
	homos->sek[i].let = first_S->sek[i].let; 
	j = 1;
	for (cur_s = first_S->next; cur_s && cur_s->ordre <= total; cur_s = cur_s->next) {
		if (homos->sek[i].let == cur_s->sek[i].let){
			j++;
		}
	}
	if (j> 0.75*total){
		if (j != total+1)
			homos->sek[i].let = homos->sek[i].let - 'A' + 'a';	
		continue;
	}
	else
		homos->sek[i].let = VIDE;
	if (homos->sek[i].let == '.' && HYDRE[first_S->sek[i].let-'A'] == 1){
		homos->sek[i].let = '/'; 
		for (cur_s = first_S->next; cur_s && cur_s->ordre <= total; cur_s = cur_s->next) {
			if (cur_s->sek[i].let == VIDE || HYDRE[cur_s->sek[i].let-'A'] != 1){
				homos->sek[i].let = VIDE; 
				break;
			}
		}
	}
}
	
return homos;
}
/*--------------------------------------------------------------*/
/* ecriture d'un fichier de type MSF				*/
/*--------------------------------------------------------------*/
SEQ	*questionnaire(SEQ *prot)
{
	char	total[5], let, nunu[15];

	if (TOT == 0 || TOT  > ordre_max || SCO == 0){	
		TOT = ordre_max;
		fprintf(stdout, "\n How many sequences to align [* 0 _ %d *]? ",TOT);
		gets(total);
		sscanf(total,"%d",&TOT);
	}
	if (!CONS){
		fprintf(stdout, "\n Computes consensus sequence [* n *]? ");
		gets(total);
		if (total[0] == 'y')
			CONS = 1;
	}
	if (CONS) {	
		homologie(prot, numN, numC, TOT);
		TOT++;
	}
return prot;
}
/*--------------------------------------------------------------*/
/* ecriture d'un fichier de type MSF				*/
/*--------------------------------------------------------------*/
void	sortie(FILE *out, SEQ *prot)
{
	char	total[5], let, nunu[15];
	int 	start, incre = 0,i,longue;
	SEQ	*cur_s = prot;

	fprintf(stdout, "\n Alignment starts at [* %d *]? ",numN);
	gets(nunu);
	sscanf(nunu,"%d",&numN);

	numC = N_TOT;
	fprintf(stdout, "\n Alignment ends at [* %d *]? ",numC);
	gets(nunu);
	sscanf(nunu,"%d",&numC);
	
	longue = numC - numN +1;

	for (start = numN; start <= numC; start++, longue--){
		if (prot->sek[start].let != VIDE)
			break;
	}
	prot = questionnaire(prot);

fprintf(out," %s  Msf: %d  Type: P  PileUp-like from BlastP  Check: 1995  ..\n\n",file_out,longue);


for (cur_s = prot; (cur_s && cur_s->ordre <= TOT); cur_s = cur_s->next ) {
	cur_s->check = SeqGCGCheckSum(cur_s, longue, start);
	fprintf(out," Name: %-10s       Len: %5d  Check: %4d  Weight:  1.00\n",cur_s->name,longue, cur_s->check);
}
fprintf(out,"\n//\n\n");

  while (start <= numC ){
		fprintf(out,"            %-5d",start);
		for (i = 20; i < ligne_max; i+=10)
			fprintf(out,"           ");
	if (ligne_max + start < numC)
		fprintf(out,"           %5d\n",ligne_max - 1 + start);
	else
		fprintf(out,"           \n");

	for (cur_s = prot; (cur_s && cur_s->ordre <= TOT); cur_s = cur_s->next ) {
		fprintf(out,"%10s  ",cur_s->name);
		for (i = 0; i < ligne_max && (i + start) <= numC; i++) {
			fprintf(out,"%c", cur_s->sek[i+start].let);
			if ((i+1)%10 == 0)
				fprintf(out," ");	
		}
		fprintf(out,"\n");
	}
	start += i;
	fprintf(out,"\n");
  }

	fclose(out);
	fprintf(stdout, "\n\n             Output file name: %s \n\n",file_out);

}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
SEQ	*lecture_ligne(char line[LINE_LENGTH], int beg, int end, int num, SEQ *cur)
{
	int	i;
	char	e;

	for (i = 0; i < end && i+num <= N_TOT; i++) {
	   if ((e = line[i+beg]) >= 'A' && e <= 'Z') {
		cur->sek[num+i].let = line[beg+i];
	   }
	}

return cur;
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
void	lecture_alignement(FILE *in)
{
	char	name[10], score[60], let, e, line[LINE_LENGTH];
	int 	nombre = 0, i = 0, pos = 0, num_n = 0, num_c = 0;
	SEQ	*cur_s = NULL, *prot = NULL;

       if ( !(prot = new_seq(prot, N_TOT)) )
                exit(1);
        else {
                strncpy(prot->name, "Query\0",10);
                strncpy(prot->code, "Query\0",6);
                prot->num_N = 1;
                prot->num_C = N_TOT;
                cur_s = prot;
        }


   while ( fgets(line,LINE_LENGTH,in) ) {
        if (('>' == line[0]) || (PDB == 1 && (strncmp(line, "</form>", 7)== 0))){
		ordre_max++;  		 /*  pour l'ordre de la sequence */
		cur_s = prot_name(cur_s, line, nombre++);
	}
	else
        if (strncmp("Query: ", line, BORD)== 0){
		sscanf(line + BORD ,"%d", &num_n_abs);      
		for (i = BORD; i < LINE_LENGTH; i++)
			if (line[i] >= 'A' && line[i] <= 'Z')
				break;
		prot = lecture_ligne(line, i, strlen(line), num_n_abs, prot);
	}        
	else 
	if (strncmp("Sbjct: ", line, BORD)== 0){
		sscanf(line + BORD ,"%d", &num_n);      
		if (cur_s->num_N > num_n)
			cur_s->num_N = num_n;
		for (i = BORD; i < LINE_LENGTH; i++)
			if (line[i] >= 'A' && line[i] <= 'Z')
				break;
		cur_s = lecture_ligne(line, i, strlen(line), num_n_abs, cur_s);
	}
	for (i = 0; i < LINE_LENGTH; i++) line[i] = '\0';
   }

	fclose(in);

	sortie(out, prot);

}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
void	recherche_score(FILE *in)
{

int 	i = 0, pos = 0, num_n = 0, num_c = 0;
char	score[60], let, e, line[LINE_LENGTH];
double	scor = 0.0;

   while ( fgets(line,LINE_LENGTH,in) ) {

	if (strncmp("Sequences producing High-scoring Segment Pairs",line,36)== 0){
		fgets(line,LINE_LENGTH,in);
		fgets(line,LINE_LENGTH,in);
		if (PDB && strncmp(line,"<B>",3) == 0)
			fgets(line,LINE_LENGTH,in);
		fgets(line,LINE_LENGTH,in);
		HTML = size_html(line);
		sscanf(line + 68 + HTML,"%e",&scor);
		if (SCO == 0 && TOT == 0){
			fprintf(stdout, "\n maximum score [* %2.2lf *]? ",score_max);	
			gets(score);
			if (sscanf(score, "%lf",&score_max) == 1)
				SCO = 1; 
/*	fprintf(stdout, "\n\tmaxi %lf HTML %d\n", score_max, HTML); */
		}
		while ((line[0] != ' ' && scor < score_max)){
			fgets(line,LINE_LENGTH,in);
			HTML = size_html(line);
/*		fprintf(stdout, "%s\tmax:%e ET html:%d\n",line+68+HTML, score_max, HTML);*/
			sscanf(line + 68 + HTML,"%e",&scor);
			TOT++;
			/* fprintf(stdout, "score %e", scor); */
		}
/* fprintf(stdout, " TOT %d\n", TOT); */
		break;
	}
  }
}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
void	recherche_debut(FILE *in)
{
int 	i = 0, pos = 0, num_n = 0, num_c = 0;
char	line[LINE_LENGTH], name[10],
	*tok = NEWN(LINE_LENGTH, char);

	while ( fgets(line,LINE_LENGTH,in) ) {
        	if (strncmp("Query=",&line[0],6)== 0){
        		if (strncmp("Query=  TITLE",&line[0],13)== 0)
				sscanf(line + 14 ,"%10c",name);
			else 
				sscanf(line + 8 ,"%10c",name);
			break;
		}
	}
	if ( !fgets(line,LINE_LENGTH,in)) exit(1);
	else
      		tok = strtok(line+9,"()");
	sscanf(tok ,"%d",&N_TOT);      
	fprintf(stdout,"\nsequence length: %d\n", N_TOT);

	while ( fgets(line,LINE_LENGTH,in) ) {
       		if (strncmp("Database:",line,9)== 0){
        		if (strncmp(line+11, "Brookhaven Protein Data Bank",28)== 0)
				PDB = 1;
			else 
				PDB = 0;
			break;
		}
	}

}
/*--------------------------------------------------------------*/
/*								*/
/*--------------------------------------------------------------*/
main(int argc,char **argv)
{

	if (!parseargstr(argc,argv)) exit(1);	

	recherche_debut(in);
	recherche_score(in);
	lecture_alignement(in);

/*	fprintf(stdout, "\n\n                      -  THE END  -              \n");*/

}
